﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private manager As WifiManager
	Public  discoveredDevices As List
	Private server As ServerSocket
	Private client As Socket
	Private port As Int = 13138
	Private astream As AsyncStreams
	Private directConnected As Boolean
	Private groupIp As String
	Public lblEnabledText, lblConnectedText, lblDevicesText As String
	Public btnSendHelloEnabled = False, btnSendTextFileEnabled = False, btnConnectEnabled = True As Boolean
End Sub

Sub Service_Create
	server.Initialize(port, "server")
	manager.Initialize("manager")	
End Sub

Sub Manager_EnabledChanged (Enabled As Boolean)
	Log("Enabled: " & Enabled)
	lblEnabledText = Enabled
	UpdateUI
End Sub

Public Sub Connect(WhichDevice As Int)
	lblConnectedText = "Trying to connect..."
	If directConnected = False Then
		'create the p2p connection
		If discoveredDevices.IsInitialized = False Or discoveredDevices.Size = 0 Then 
			ToastMessageShow("No peered devices.", True)
			Return
		End If
		

		If  WhichDevice >= 0 And WhichDevice < discoveredDevices.Size Then
			Dim dev As WifiDevice = discoveredDevices.Get(WhichDevice)
		
			manager.Connect(dev.MacAddress)
		End If
	Else
		If astream.IsInitialized Then 
			Return 'there is already a network connection
		End If
		'there is already a p2p connection
		ConnectNetwork
	End If
	UpdateUI
End Sub

Public Sub Discover
	lblDevicesText = "Searching for devices"
	manager.DiscoverPeers
	UpdateUI
End Sub

Sub Manager_PeersDiscovered (Success As Boolean, Devices As List)
	Log("peers: " & Success)
	
	If Success Then
		discoveredDevices = Devices

		lblDevicesText = discoveredDevices.Size
	Else
		lblDevicesText = "0"
	End If
	
	UpdateUI
End Sub

Public Sub SendMessage(Message As String)
			astream.Write(Message.GetBytes("UTF8"))
End Sub


Public Sub SendFile(FileDir As String, FileName As String)
			astream.Write(File.ReadString(FileDir, FileName).GetBytes("UTF8"))
End Sub


Sub Manager_ConnectionChanged (Connected As Boolean, GroupOwnerIp As String)
	directConnected = Connected
	groupIp = GroupOwnerIp
	If Connected Then
		lblConnectedText = "Wifi Direct connected (" & GroupOwnerIp & ")"
		ConnectNetwork
	Else
		lblConnectedText = "false"
	End If
	btnConnectEnabled = Not(Connected)
	
	UpdateUI
End Sub

Sub ConnectNetwork
'	If groupIp = "192.168.1.1" Then
	
	If groupIp = "127.0.0.1" Then
		server.Listen
	Else
		Log("trying to connect to server socket.")
		client.Initialize("client")
		client.Connect(groupIp, port, 10000)
	End If
End Sub

Sub client_Connected (Successful As Boolean)
	If Successful Then
		StartAsyncStreams(client)
	Else
		lblConnectedText = "client failed to connect."
		btnConnectEnabled = True
		UpdateUI
	End If
End Sub

Sub server_NewConnection (Successful As Boolean, NewSocket As Socket)
	Log("server_NewConnection " & Successful)
	If Successful Then
		StartAsyncStreams(NewSocket)
	End If
	server.Listen
End Sub

Private Sub UpdateUI
	CallSub(Main, "UpdateUI")
End Sub

Sub StartAsyncStreams(s As Socket)
	Log("AsyncStreams started")
	astream.InitializePrefix(s.InputStream, False,  s.OutputStream, "astreams")
	btnSendHelloEnabled = True
	btnSendTextFileEnabled = True
	btnConnectEnabled = False
	lblConnectedText = "Sockets are connected :-)"
	UpdateUI
End Sub

Sub astreams_NewData (Buffer() As Byte)
	ToastMessageShow("Message from other device: " & BytesToString(Buffer, 0, Buffer.Length, "UTF8"), True)
	
	Log(BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
End Sub

Sub astreams_Error
	Log("astreams_Error")
	ToastMessageShow(LastException, True)
	Log(LastException)
	astream.Close
	astreams_Terminated
End Sub

Sub astreams_Terminated
	Log("astreams_Terminated")
	btnSendHelloEnabled = False
	btnSendTextFileEnabled = False
	btnConnectEnabled = True
	lblConnectedText = "Sockets disconnected"
	UpdateUI
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy

End Sub
